﻿define([
    "dojo",
    "dojo/_base/declare",
    "dojo/on",
    "dojo/parser",    
    "epi/shell/command/_Command",
    "epi/shell/_ContextMixin",
    "dojo/dom-construct",
    "dojo/text!../epi-modal.html",
    "dijit/Dialog",
    "dijit/form/Button",
    "dojo/domReady!"
], function (dojo, declare, on, parser, _Command, _ContextMixin, domConst, template) {    

    return declare([_Command, _ContextMixin], {
        contentQuery: null,
        label: "Create New Translation Project",
        iconClass: "epi-iconPlus",

        constructor: function () {
            // Set the model to the initial context.
            this.set("model", this._currentContext);
        },

        _execute: function () {
            let hideAll = function () {
                dojo.destroy('niteco-epi-modal');
                dojo.destroy('niteco-epi-hidden-layout');
            }

            var x = this.contentQuery;
            var store = this.store;
            var result = this.model.id;

            let modal = dojo.byId('niteco-epi-modal');
            let hiddenLayout = dojo.byId('niteco-epi-hidden-layout');

            if (!hiddenLayout) {
                dojo.body().insertAdjacentHTML("beforeEnd", template);
                hiddenLayout = dojo.byId('niteco-epi-hidden-layout');
                modal = dojo.byId('niteco-epi-modal');
            }
            else
                hideAll();

            let nameField = dojo.byId('niteco-epi-name-field');
            let okBtn = dojo.byId('niteco-epi-ok-button');
            let cancelBtn = dojo.byId('niteco-epi-cancel-button');
            let closeTextBtn = dojo.byId('niteco-epi-close-text');

            on(cancelBtn, 'click', function (evt) {
                hideAll();
            });

            on(closeTextBtn, 'click', function (evt) {
                hideAll();
            });

            on(okBtn, 'click', function (evt) {
                let proName = nameField.value;
                if (proName) {
                    result = result + '-' + proName;
                }
                hideAll()
                $('.loadingDiv').fadeIn(500);
                store.put(result).then(function (item) {
                    x.set("queryParameters", { workspace: 1, page: 1 });
                    x.set("queryName", "WorkspaceQuery");

                    if (typeof LionBridgeConnectorGrid !== "undefined" && typeof LionBridgeConnectorJs !== "undefined") {
                        LionBridgeConnectorGrid.clearFilter();
                        LionBridgeConnectorJs.onSetArchiving(true);
                        LionBridgeConnectorGrid.onToggleArchivingView('#archive6bb3b40543354773812682476d110c8f');
                        //LionBridgeConnectorGrid.onReloadGrid();
                    }

                    if (item !== undefined && item.itemLink !== undefined && item.itemLink !== '') {
                        window.location.href = item.itemLink;
                    }
                    $('.loadingDiv').fadeOut(500);
                });
            });
          
        },

        _onModelChange: function () {
            this.set("canExecute", !!this.model);
        },

        contextChanged: function (context) {
            // Update the model to the new context when it changes.
            this.set("model", context);
        }

        
    });
})