﻿define([
    "dojo/_base/declare",
    "epi/dependency",
    "epi/routes",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/command/_Command"
], function (declare, dependency, routes, Alert, _Command) {

    return declare([_Command], {
        store: null,
        contentQuery: null,

        label: "Cancel Project",
        iconClass: "epi-iconRevert",
        category: "context",

        _execute: function () {
            $('.loadingDiv').fadeIn(500);
            var registry = dependency.resolve("epi.storeregistry");
            var store = registry.get("workspace.translationprojectstore");
            var id = this.model.contentLink + ";" + "cancel";

            store.put(id).then(function (item) {
                if (item != undefined && item.error) {
                    var errorDialog = new Alert({
                        heading: "Cancel project",
                        description: "Something went wrong when cancelling the project due to: " + item.errorMessage
                    });
                    errorDialog.show();
                } else {
                    var dialog = new Alert({
                        heading: "Cancelled",
                        description: "Please note that cancelling this project will not cause translation work to stop. Please contact Lionbridge to ensure that your work is stopped.",
                    });
                    dialog.show();
                }
                $('.loadingDiv').fadeOut(500);
            });

            this.contentQuery.set("queryParameters", { workspace: 1, page: 1 });
            this.contentQuery.set("queryName", "WorkspaceQuery");

            if (typeof LionBridgeConnectorGrid !== "undefined") {
                LionBridgeConnectorGrid.onReloadGrid();
            }
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated. Subclasses should override this method.
            // tags:
            //      protected
            var sendLink = this;
            var registry = dependency.resolve("epi.storeregistry");
            var store = registry.get("workspace.translationprojectstore");
            dojo.when(store.get(this.model.contentLink + "?" + Math.random() * 9999999999), function (item) {

                if (item.status == 1 || item.status == 2) {
                    sendLink.set("canExecute", true);
                } else {
                    sendLink.set("canExecute", false);
                }

                if (item.isSending) {
                    sendLink.set("canExecute", true);
                }
            });
        }
    });
})