﻿define([
    "dojo",
    "dojo/_base/declare",
    "epi/shell/widget/dialog/Alert",
    "epi/dependency",
    "epi/routes",
    "epi/shell/command/_Command"
], function (dojo, declare, Alert, dependency, routes, _Command) {

    return declare([_Command], {
        store: null,
        contentQuery: null,
        // canExecute: true,
        iconClass: "epi-iconProject",
        label: "Clone job",
        category: "context",

        _execute: function () {
            //$('.loadingDiv').fadeIn(500);
            LionBridgeConnectorJs.dojo.body().insertAdjacentHTML("beforeEnd", LionBridgeConnectorJs.epiModal);
            let modal = LionBridgeConnectorJs.dojo.byId('niteco-epi-modal');
            let hiddenLayout = LionBridgeConnectorJs.dojo.byId('niteco-epi-hidden-layout');
            let nameField = LionBridgeConnectorJs.dojo.byId('niteco-epi-name-field');
            let okBtn = LionBridgeConnectorJs.dojo.byId('niteco-epi-ok-button');
            let cancelBtn = LionBridgeConnectorJs.dojo.byId('niteco-epi-cancel-button');
            let result = 'clone' + id;

            let registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
            let store = registry.get("workspace.workspacestore");

            let hideAll = function () {
                LionBridgeConnectorJs.dojo.setStyle(modal, 'display', 'none');
                LionBridgeConnectorJs.dojo.setStyle(hiddenLayout, 'display', 'none');
            }

            LionBridgeConnectorJs.dojoOn(okBtn, 'click', function (evt) {
                let proName = nameField.value;
                if (proName) {
                    result = result + '-' + proName;
                }
                store.put(result).then(function (item) {
                    $('.loadingDiv').fadeIn(500);
                    hideAll();
                    if (typeof LionBridgeConnectorGrid !== "undefined" && typeof LionBridgeConnectorJs !== "undefined") {
                        LionBridgeConnectorGrid.clearFilter();
                        LionBridgeConnectorJs.onSetArchiving(true);
                        LionBridgeConnectorGrid.onToggleArchivingView('#archive6bb3b40543354773812682476d110c8f');
                        //LionBridgeConnectorGrid.onReloadGrid();
                    }

                    if (item !== undefined && item.itemLink !== undefined && item.itemLink !== '') {
                        window.location.href = item.itemLink;
                    }
                });
            });

            LionBridgeConnectorJs.dojoOn(cancelBtn, 'click', function (evt) {
                hideAll();
            });
            this.contentQuery.set("queryParameters", { workspace: 1, page: 1 });
            this.contentQuery.set("queryName", "WorkspaceQuery");

        },

        _onModelChange: function () {

        }
    });
})