﻿define([
    "dojo/_base/declare",
        "epi/dependency",
            "epi/routes",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/command/_Command"
], function (declare, dependency, routes, Alert, _Command) {

    return declare([_Command], {
        store: null,
        contentQuery: null,

        label: "Import translations",
        iconClass: "epi-iconDownload",
        category: "context",

        _execute: function () {
            $('.loadingDiv').fadeIn(500);
            var registry = dependency.resolve("epi.storeregistry");
            this.store = registry.get("workspace.importprojectstore");
            dojo.when(this.store.put(this.model.contentLink), function (item) {
                if (item.error) {
                    var errorDialog = new Alert({
                        heading: "Project not sent",
                        description: "Something went wrong when importing the project: " + item.errorMessage
                    });
                    errorDialog.show();
                }
                else {
                    var dialog = new Alert({
                        heading: "Imported",
                        description: "The project has been imported, but has not been published. Please review the translations."
                    });
                    dialog.show();

                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                        LionBridgeConnectorGrid.onReloadGrid();
                    }
                }
                $('.loadingDiv').fadeOut(500);
            });

            this.contentQuery.set("queryParameters", { workspace: 1, page: 1 });
            this.contentQuery.set("queryName", "WorkspaceQuery");
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated. Subclasses should override this method.
            // tags:
            //      protected
            var sendLink = this;
            var registry = dependency.resolve("epi.storeregistry");
            var store = registry.get("workspace.translationprojectstore");
            dojo.when(store.get(this.model.contentLink + "?" + Math.random() * 9999999999), function (item) {
                
                if (item.unimportedContent) {
                    sendLink.set("canExecute", true);
                } else {
                    sendLink.set("canExecute", false);
                }
            });
        }
    });
})